/******************************************************************************
 * Copyright (c) 2013-2015, Texas Instruments Incorporated - http://www.ti.com/
 *   All rights reserved.
 *
 *   Redistribution and use in source and binary forms, with or without
 *   modification, are permitted provided that the following conditions are met:
 *       * Redistributions of source code must retain the above copyright
 *         notice, this list of conditions and the following disclaimer.
 *       * Redistributions in binary form must reproduce the above copyright
 *         notice, this list of conditions and the following disclaimer in the
 *         documentation and/or other materials provided with the distribution.
 *       * Neither the name of Texas Instruments Incorporated nor the
 *         names of its contributors may be used to endorse or promote products
 *         derived from this software without specific prior written permission.
 *
 *   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 *   AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 *   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 *   ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 *   LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 *   CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 *   SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 *   INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 *   CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 *   ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 *   THE POSSIBILITY OF SUCH DAMAGE.
 *****************************************************************************/
#define __CL_ENABLE_EXCEPTIONS
#include <CL/cl.hpp>
#include <iostream>
#include <cstdio>
#include <fstream>
#include <cstdlib>
#include <cstdio>
#include <signal.h>
#include "ocl_util.h"
#include "gaussRandom.h"

#define   MAXIMUM_NUMBER_ELEMENT    (32*1024)

using namespace cl;
using std::cout;
using std::cerr;
using std::endl;

static  double clock_diff (struct timespec *t1, struct timespec *t2);


FILE  *fp   ;
#include "utilityRoutines.h"
#include "generateRandomGaissian.h"



/******************************************************************************
* main
******************************************************************************/
int main(int argc, char *argv[])
{
   /*-------------------------------------------------------------------------
   * Catch ctrl-c so we ensure that we call dtors and the dsp is reset properly
   *------------------------------------------------------------------------*/
   struct timespec tp_start, tp_end;
   struct initial_t vector[8]  ;
   int index  ;
   long numberOfLoops , i   ;
   float  x,y ,z ;
   float outputResults[MAXIMUM_NUMBER_ELEMENT]  ;


     fp = fopen("gaussianOut.txt","w") ;
     if (fp!=NULL)
     {
       printf ("open Out file %s",fp);

     } else
     {
         printf ("Could not open Out file %s",fp);
     }

        initializeInit(vector) ;




   /*--------------------------------------------------------------------------
   * Initialize the input matrices to random data
   *-------------------------------------------------------------------------*/
     x = (float) MAXIMUM_NUMBER_ELEMENT   ; 
     clock_gettime(CLOCK_MONOTONIC, &tp_start);

     longPseudoRandom(vector,0,MAXIMUM_NUMBER_ELEMENT, outputResults)  ;


     clock_gettime(CLOCK_MONOTONIC, &tp_end);

     double elapsed = clock_diff (&tp_start, &tp_end);
     printf("measuring Gaussian  time  %lf nano secs\n",  elapsed);

     printf(" processed   %f elements , nanosecond per element  %f \n",
              x, elapsed/x  )   ;
//   write_X_Y_W_to_file(fp, scratch1, scratch2, 1024)   ;
   write_float_file(fp, outputResults, MAXIMUM_NUMBER_ELEMENT) ;

  fclose (fp) ;
  printf("DONE   \n");
	return 0;

}


static double clock_diff (struct timespec *t1, struct timespec *t2)
       { return t2->tv_sec - t1->tv_sec + (t2->tv_nsec - t1->tv_nsec) ; }


